
const express = require('express')
const Article = require('./../models/article')
const router = express.Router()

//if user is not loggedin, the user is redirected to the login page
const redirectLogin = (req, res, next) => { if 
(!req.session.userId ) {
	 res.redirect('./login') }
 else { next (); } }

//get route renders new page to add food details
router.get('/new', redirectLogin, (req, res) => {
  res.render('articles/new', { article: new Article() })
});

//route to edit food data using particular food id
router.get('/edit/:id',redirectLogin, async (req, res) => {
  const article = await Article.findById(req.params.id)
	  res.render('articles/edit', { article: article}) });

//save food data and redirect to foodpage
router.post('/', async (req, res, next) => {
	        req.article = new Article()
	         next()
}, saveArticleAndRedirect('https://www.doc.gold.ac.uk/usr/397/foodpage'));


//ejs template displays food data using slug 
router.get('/:slug', async (req, res) => {
const article = await Article.findOne({ slug: req.params.slug })
	 if (article == null) res.redirect('https://www.doc.gold.ac.uk/usr/397/foodpage')
	res.render('articles/show', { article: article })
});

//cart ejs page displays data using slug
router.get('/cart/:slug', async (req, res) => {
const article = await Article.findOne({ slug: req.params.slug })
if (article == null) res.redirect('https://www.doc.gold.ac.uk/usr/397/foodpage');
	res.render('articles/cart', { article: article })
});

//edit and update food data with the help of unique id
router.put('/:id', async (req, res, next) => {
        req.article = await Article.findById(req.params.id)
	        next()
}, saveArticleAndRedirect('edit'))

//delete food using unique id
router.delete('/:id', async (req, res) => {
	        await Article.findByIdAndDelete(req.params.id)
         res.redirect('https://www.doc.gold.ac.uk/usr/397/foodpage') });

//save and redirect function
function saveArticleAndRedirect(path) {
	        return async (req, res) => {
         let article = req.article
        article.name = req.body.name                                                       
        article.typicalvalues= req.body.typicalvalues  
	article.unitvalue = req.body.unitvalue 
	article.calories = req.body.calories 
	article.carbs = req.body.carbs  
	article.fat = req.body.fat                  
        article.protein = req.body.protein          
	article.salt = req.body.salt                       
	 article.sugar = req.body.sugar                                                            
	 try { article= await article.save()
	 res.redirect('https://www.doc.gold.ac.uk/usr/397/savedpage')
	 } catch (e) {
	res.send( '<a href='+'https://www.doc.gold.ac.uk/usr/397'+'>Home</a>'+ '<br />'
	+'Link to homepage');

		} } }
module.exports = router;                                                                   
                                                    





